// Browser detection library
// Capabilities detection
// Author:	Roland Smeenk
// Website: www.smeenk.com

function doError(a1,a2,a3) {
	str = 'An error occured on this page.\n';
	str += 'Error: ' + a1;
	str += '\nFile: ' + a2;
	str += '\nLine: ' + a3;
	alert(str);
	return true;
}
window.onerror = doError;

function Is ()
{   
var agt=navigator.userAgent.toLowerCase();
var apv=navigator.appVersion;
// Detect browser version
this.major = parseInt(apv);
this.minor = parseFloat(apv);
// Detect browser type
this.nav = ((agt.indexOf('mozilla')!=-1) && (agt.indexOf('spoofer')==-1)
 && (agt.indexOf('compatible') == -1) && (agt.indexOf('opera')==-1) 
 && (agt.indexOf('webtv')==-1));
this.nav2 = (this.nav && (this.major == 2));
this.nav3 = (this.nav && (this.major == 3));
this.nav3up = (this.nav && (this.major >= 3));
this.nav4 = (this.nav && (this.major == 4));
this.nav4up = this.nav && (this.major >= 4);
this.nav5 = (this.nav && (this.major == 5));
this.nav5up = (this.nav && (this.major >= 5));
this.navonly  = (this.nav && ((agt.indexOf(";nav") != -1) || (agt.indexOf("; nav") != -1)));

this.ie   = (agt.indexOf("msie") != -1);
this.ie3  = (this.ie && (this.major < 4));
this.ie4  = (this.ie && (this.major == 4) && (agt.indexOf("msie 5.0")==-1) );
this.ie4up  = (this.ie  && (this.major >= 4));
this.ie5  = (this.ie && (this.major == 4) && (agt.indexOf("msie 5.0")!=-1) );
this.ie5up  = (this.ie  && !this.ie3 && !this.ie4);

this.aol   = (agt.indexOf("aol") != -1);
this.aol3  = (this.aol && this.ie3);
this.aol4  = (this.aol && this.ie4);

this.opera = (agt.indexOf("opera") != -1);
this.webtv = (agt.indexOf("webtv") != -1);

// Low level javascript (ie3.02)
this.low = (!this.nav && !this.ie && !this.opera) ? true:false
     
// Detect Javascript version
if (this.nav2 || this.ie3) this.js = 1.0
else if (this.nav3 || this.opera) this.js = 1.1
else if ((this.nav4 && (this.minor <= 4.05)) || this.ie4) this.js = 1.2
else if ((this.nav4 && (this.minor > 4.05)) || this.ie5) this.js = 1.3
else if (this.nav5) this.js = 1.4
else if (this.nav && (this.major > 5)) this.js = 1.4
else if (this.ie && (this.major > 5)) this.js = 1.3
else this.js = 0.0;

this.win   = ((agt.indexOf("win")!=-1) || (agt.indexOf("16bit")!=-1));
this.win95 = ((agt.indexOf("win95")!=-1) || (agt.indexOf("windows 95")!=-1));
this.win16 = ((agt.indexOf("win16")!=-1) ||
(agt.indexOf("16bit")!=-1) || (agt.indexOf("windows 3.1")!=-1) ||
(agt.indexOf("windows 16-bit")!=-1) );
this.win31 = ((agt.indexOf("windows 3.1")!=-1) || (agt.indexOf("win16")!=-1) ||
(agt.indexOf("windows 16-bit")!=-1));
this.win98 = ((agt.indexOf("win98")!=-1) || (agt.indexOf("windows 98")!=-1));
this.winnt = ((agt.indexOf("winnt")!=-1) || (agt.indexOf("windows nt")!=-1));
this.win32 = ( this.win95 || this.winnt || this.win98 ||
((this.major >= 4) && (navigator.platform == "Win32")) ||
(agt.indexOf("win32")!=-1) || (agt.indexOf("32bit")!=-1) );
this.os2   = ((agt.indexOf("os/2")!=-1) ||
(apv.indexOf("OS/2")!=-1) ||
(apv.lastIndexOf("OS2") != -1) ||
(agt.indexOf("ibm-webexplorer")!=-1));
this.mac    = (agt.indexOf("mac")!=-1);
this.mac68k = (this.mac && ((agt.indexOf("68k")!=-1) ||
(agt.indexOf("68000")!=-1)));
this.macppc = (this.mac && ((agt.indexOf("ppc")!=-1) ||
(agt.indexOf("powerpc")!=-1)));
this.sun   = (agt.indexOf("sunos")!=-1);
this.sun4  = (agt.indexOf("sunos 4")!=-1);
this.sun5  = (agt.indexOf("sunos 5")!=-1);
this.suni86= (this.sun && (agt.indexOf("i86")!=-1));
this.irix  = (agt.indexOf("irix") !=-1);    // SGI
this.irix5 = (agt.indexOf("irix 5") !=-1);
this.irix6 = ((agt.indexOf("irix 6") !=-1) || (agt.indexOf("irix6") !=-1));
this.hpux  = (agt.indexOf("hp-ux")!=-1);
this.hpux9 = (this.hpux && (agt.indexOf("09.")!=-1));
this.hpux10= (this.hpux && (agt.indexOf("10.")!=-1));
this.aix   = (agt.indexOf("aix") !=-1);      // IBM
this.aix1  = (agt.indexOf("aix 1") !=-1);
this.aix2  = (agt.indexOf("aix 2") !=-1);
this.aix3  = (agt.indexOf("aix 3") !=-1);
this.aix4  = (agt.indexOf("aix 4") !=-1);
this.linux = (agt.indexOf("inux")!=-1);
this.sco   = (agt.indexOf("sco")!=-1) || (agt.indexOf("unix_sv")!=-1);
this.unixware = (agt.indexOf("unix_system_v")!=-1);
this.mpras    = (agt.indexOf("ncr")!=-1);
this.reliant  = (agt.indexOf("reliantunix")!=-1);
this.dec   = ((agt.indexOf("dec")!=-1) || (agt.indexOf("osf1")!=-1) ||
(agt.indexOf("dec_alpha")!=-1) || (agt.indexOf("alphaserver")!=-1) ||
(agt.indexOf("ultrix")!=-1) || (agt.indexOf("alphastation")!=-1));
this.sinix = (agt.indexOf("sinix")!=-1);
this.freebsd = (agt.indexOf("freebsd")!=-1);
this.bsd = (agt.indexOf("bsd")!=-1);
this.unix  = ((agt.indexOf("x11")!=-1) || this.sun || this.irix || this.hpux ||
 this.sco ||this.unixware || this.mpras || this.reliant ||
 this.dec || this.sinix || this.aix || this.linux || this.bsd || this.freebsd);
this.vms   = ((agt.indexOf("vax")!=-1) || (agt.indexOf("openvms")!=-1));
this.rhapsody = (agt.indexOf("rhapsody") != -1 );
this.openstep = (agt.indexOf("openstep") != -1 );
this.nextos =  (agt.indexOf("next") != -1);
this.solaris = (agt.indexOf("solaris") != -1);
}

function Caps ()
{   
this.midi = ((is.nav3up && navigator.mimeTypes["audio/x-midi"]) || is.ie4up)  ? true:false;
this.wav = ((is.nav3up && navigator.mimeTypes["audio/x-wav"]) || is.ie4up)  ? true:false;
this.navdhtml = (document.layers) ? true:false;
this.iedhtml = (document.all) ? true:false;
this.dhtml = (this.navdhtml || this.iedhtml);
this.image = (document.images) ? true:false;
this.width = 0;
this.height = 0;
this.colorDepth = 0;
if (screen)
{if (screen.width) this.width = screen.width;
if (screen.height) this.height = screen.height;
if (screen.colorDepth) this.colorDepth = screen.colorDepth;
if ((!screen.width) && (is.nav) && (navigator.javaEnabled()))
{var toolkit = java.awt.Toolkit.getDefaultToolkit();
var screen_size = toolkit.getScreenSize();
this.width = screen_size.width;
this.height = screen_size.height;
}
}
this.apabi = IEDetectObject("Check.CheckReader") || IEDetectObject("Check.CheckReader") || NavFindObject("Check.CheckReader");
this.cp20 = (is.win32 && NavDetectObject("Cosmo Player 2.0")) ||
NavDetectObject("Cosmoplayer Plugin") ||
IEDetectObject("SGI.CosmoPlayer.1");
this.cp21 = (is.win32 && NavFindObject("Cosmo Player 2.1")) ||
IEDetectObject("SGI.CosmoPlayer.2");
this.cp = (is.irix && NavDetectObject("libcosmoplayer.so")) || this.cp20 || this.cp21;
this.pv = (NavDetectObject("Nexternet Player 1.0") || 
IEDetectObject("Nexternet.NexternetPlayer.1"));
this.wv20 = NavDetectObject("WorldView 2.0 for Netscape Navigator") ||
IEDetectObject("WorldView.WorldView VrmlViewer.1");
this.wv21 = IEDetectObject("WorldView.WorldView VrmlViewer.2");
this.ms = IEDetectObject("MSVRML2C.VRMLBrowserCtl.1");
this.wv = this.wv20 || this.wv21 || IEDetectObject("WORLDVIEW.WorldViewCtrl.1") || this.ms;
this.l3d = NavDetectObject("Live3D Plugin DLL");
this.vs = NavDetectObject("Viscape for Netscape Navigator") ||
IEDetectObject("Virtual_Worlds");
this.vsu = NavDetectObject("Viscape Universal") ||
IEDetectObject("Viscape VRML control");
this.bs = NavFindObject("blaxxun Contact (blaxxun CCpro)") || 
NavFindObject("blaxxun CC3D") ||
IEDetectObject("blaxxunCC3D.blaxxunCC3D.1");
this.ct = NavDetectObject("Cortona VRML Client") ||
IEDetectObject("Cortona.Control.1");
this.vrml = (this.cp || this.wv || this.vsu || this.bs || this.ct || this.pv);
}

var result;
// Detection of a plugin inside Internet Explorer on Windows
function IEDetectObject(ClassID)
{
	result = false;
	if ((is.ie) && (is.win))
	{
		document.write('<SCRIPT LANGUAGE=VBScript\> \n');
		document.write('on error resume next \n');
		document.write('result = IsObject(CreateObject("' + ClassID + '")) \n');
		document.write('</SCRIPT\> \n');
	}
	return result;
}

// Detection of a plugin inside Netscape Navigator
// Only for exact matches of the teststring
function NavDetectObject(teststring)
{
	result = false;
	if (is.nav)
	{	
		result = (navigator.plugins[teststring]) ? true:false;
	}

	return result;
}

// Detection of a plugin inside Netscape Navigator
// Finds if a plugin containing the teststring is installed 
// Slower than NavDetectObject
function NavFindObject(teststring)
{
	result = false;
	if (is.nav)
	{	
		var numPlugins = 0;
		if (navigator.plugins)
			numPlugins = navigator.plugins.length;
	
		for (var i=0; i < numPlugins; i++) 
		{
			if (navigator.plugins[i].name.indexOf(teststring) != -1)
				return true;
		}
	}
	return result;
}